Subject: Re: bug#40838: 28.0.50; [feature/native-comp] Function overrides in init.el are not honored after deferred compilation

From: Ihor Radchenko <[email-masked]>
Date: Tue, 28 Jul 2020 17:06:03 +0800

> That said this is an area I plan to fix to have it 100% compatible with
> the vanilla implementaiton once I'm done with moving all the eln file.
Great!

> My understanding was that the issue reported in this bug was not advise
> related but it could be also a side effect of?

Some of the broken functions were "redefined" with :around advice or
using el-patch. Though el-patch is working with function slots directly,
as I understand.

FYI, I do not encounter the original bug as often on the latest master.
What I noticed is that it also tends to happen when I change original
source code of the native-compiled functions and eval-sexp the new
versions. 

Best,
Ihor

Andrea Corallo <[email-masked]> writes:

> Ihor Radchenko <[email-masked]> writes:
>
>> Reopen.
>>
>> I think I found something related to this bug report in
>> exlplain-pause-mode package. See
>> https://github.com/lastquestion/explain-pause-mode/issues/65 for
>> details.
>>
>> best,
>> Ihor
>
> Hi Ihor,
>
> thanks for the finding.
>
> native-comp does not support advises to (most) primitive functions for
> performance reasons.  The elisp manual strongly discourage this practice
> tho.
>
> The issue can be worked around adding those functions into the
> `comp-never-optimize-functions' customize.
>
> That said this is an area I plan to fix to have it 100% compatible with
> the vanilla implementaiton once I'm done with moving all the eln file.
>
> My understanding was that the issue reported in this bug was not advise
> related but it could be also a side effect of?
>
> Regards
>
>   Andrea
>
> -- 
> [email-masked]

-- 
Ihor Radchenko,
PhD,
Center for Advancing Materials Performance from the Nanoscale (CAMP-nano)
State Key Laboratory for Mechanical Behavior of Materials, Xi'an Jiaotong University, Xi'an, China
Email: [email-masked], [email-masked]